-- set%CNF%SY-%SMO-%SD%SH:%SMI%EY-%EMO-%ED%EH:%EMI%T120%I%D
-- del%CNF%SY-%SMO-%SD%SH:%SMI%EY-%EMO-%ED%EH:%EMI%T120%I%D
-- TV-Browser 1.1
-- set{channel_name_external}{start_year}-{leadingZero(start_month, "2")}-{leadingZero(start_day, "2")}{leadingZero(start_hour, "2")}:{leadingZero(start_minute, "2")}{end_year}-{leadingZero(end_month, "2")}-{leadingZero(end_day, "2")}{leadingZero(end_hour, "2")}:{leadingZero(end_minute, "2")}{title}{short_info}{description}{"Lnge: "}{length_minutes}:{leadingZero(length_sec, "2")}{original_title}{episode}{original_episode}
-- del{channel_name_external}{start_year}-{leadingZero(start_month, "2")}-{leadingZero(start_day, "2")}{leadingZero(start_hour, "2")}:{leadingZero(start_minute, "2")}{end_year}-{leadingZero(end_month, "2")}-{leadingZero(end_day, "2")}{leadingZero(end_hour, "2")}:{leadingZero(end_minute, "2")}{title}{short_info}{description}{"Lnge: "}{length_minutes}:{leadingZero(length_sec, "2")}{original_title}{episode}{original_episode}

-- subroutines

on getdateForISOdate(theISODate, theISOTime)
	local myDate
	-- converts an ISO format (YYYY-MM-DD) and time to a date object
	set monthConstants to {January, February, March, April, May, June, July, August, September, October, November, December}
	
	set theISODate to (stringToList from (theISODate) for "-")
	
	set myDate to date theISOTime
	
	tell theISODate
		set year of myDate to item 1
		set month of myDate to item (item 2) of monthConstants
		set day of myDate to item 3
	end tell
	
	return myDate
end getdateForISOdate

on isoTime from dateObj
	tell dateObj
		return text 2 thru 3 of ((100 + ((its time) div hours as integer)) as string) 
			& ":" & text 2 thru 3 of ((100 + ((its time) mod hours div minutes)) as string) 
			& ":" & text 2 thru 3 of ((100 + ((its time) mod minutes)) as string)
	end tell
end isoTime


on ListToString from theList for myDelimiters
	tell AppleScript
		
		-- Diese Funktion ermglicht das Unterteilen von Strings anhand beliebiger Zeichen
		-- AppleScript wird veranlat Listeneintrge mit myDelimiters (z.B. ";") als Trennzeichen zu einem Text zu verbinden	
		set theSavedDelimiters to AppleScript's text item delimiters
		set text item delimiters to myDelimiters
		
		set outString to theList as text
		
		
		-- Um mglichen Probleme in diesem und anderen Scipts aus dem Weg zu gehen, 
		-- wird alles wieder in den vorherigen Zustand gebracht
		-- Restore the text item delimiters (in the interests of being a good citizen).
		set text item delimiters to theSavedDelimiters
		
		return outString
	end tell
end ListToString

on stringToList from theString for myDelimiters
	tell AppleScript
		
		-- Diese Funktion ermglicht das Unterteilen von Strings anhand beliebiger Zeichen
		-- AppleScript wird veranlat Text anhand von myDelimiters (z.B. ";") in Einzelteile zu zerlegen	
		set theSavedDelimiters to AppleScript's text item delimiters
		set text item delimiters to myDelimiters
		
		set outList to text items of theString
		
		
		-- Um mglichen Probleme in diesem und anderen Scipts aus dem Weg zu gehen, 
		-- wird alles wieder in den vorherigen Zustand gebracht
		-- Restore the text item delimiters (in the interests of being a good citizen).
		set text item delimiters to theSavedDelimiters
		
		return outList
	end tell
end stringToList






on isoDate from dateObj
	-- isoDate - yyyy-mm-dd - for AS 1.9.2 or higher
	-- Richard Morton & Nigel Garvey 2004
	tell dateObj
		return (its year as string) & "-" & 
			text 2 thru 3 of ((100 + (its month as integer)) as string) 
			& "-" & text 2 thru 3 of ((100 + (its day)) as string)
	end tell
end isoDate


-- this sub-routine is used to decode a three-character hex string
on decode_chars(these_chars)
	copy these_chars to {indentifying_char, multiplier_char, remainder_char}
	set the hex_list to "123456789ABCDEF"
	if the multiplier_char is in "ABCDEF" then
		set the multiplier_amt to the offset of the multiplier_char in the hex_list
	else
		set the multiplier_amt to the multiplier_char as integer
	end if
	if the remainder_char is in "ABCDEF" then
		set the remainder_amt to the offset of the remainder_char in the hex_list
	else
		set the remainder_amt to the remainder_char as integer
	end if
	set the ASCII_num to (multiplier_amt * 16) + remainder_amt
	return (ASCII character ASCII_num)
end decode_chars


-- this sub-routine is used to decode text strings
on decode_text(this_text)
	set flag_A to false
	set flag_B to false
	set temp_char to ""
	set the character_list to {}
	repeat with this_char in this_text
		set this_char to the contents of this_char
		if this_char is "%" then
			set flag_A to true
		else if flag_A is true then
			set the temp_char to this_char
			set flag_A to false
			set flag_B to true
		else if flag_B is true then
			set the end of the character_list to 
				my decode_chars(("%" & temp_char & this_char) as string)
			set the temp_char to ""
			set flag_A to false
			set flag_B to false
		else
			set the end of the character_list to this_char
		end if
	end repeat
	return the character_list as string
end decode_text

on replace_chars(this_text, search_string, replacement_string)
	set AppleScript's text item delimiters to the search_string
	set the item_list to every text item of this_text
	set AppleScript's text item delimiters to the replacement_string
	set this_text to the item_list as string
	set AppleScript's text item delimiters to ""
	return this_text
end replace_chars

on makePositive(myNumber)
	if myNumber < 0 then set myNumber to myNumber * -1
	return myNumber
end makePositive



-- main script

set myParams to POSIX file myParams

try
	set myParams to read myParams as class utf8
end try

if myParams is not "" then
	set myParams to replace_chars(myParams, "\\", "")
	set myParams to stringToList from myParams for ""
else
	return "parameter error"
end if
if (count of items of myParams) < 10 then
	return "too few parameters"
end if
-- time conversions in this script may seem a bit complicated. This is due to a) limitations in AppleScript and b) the fact that the formats in the international preferences (localisation) influences the way "date" works. we have to work around this to guarantee for the script to work on different configurations

set myStartDate to getdateForISOdate(item 3 of myParams, item 4 of myParams)
set myEndDate to getdateForISOdate(item 5 of myParams, item 6 of myParams)
set myMode to item 1 of myParams
set mySummary to decode_text(item 2 of myParams) & "" & decode_text(item 7 of myParams)
set myDescription to decode_text(ListToString from (items 9 thru -1 of myParams) for "")
set myRecurrence to ""
try
	set fuzzyTime to (item 8 of myParams as number) * minutes
on error
	set fuzzyTime to 20 * minutes
end try

tell application "iCal"
	if (exists (calendars whose title is "TV-Browser")) then
		set TVBrowserCalendar to first item of (calendars whose title is "TV-Browser")
	else
		set TVBrowserCalendar to make new calendar with properties {title:"TV-Browser"}
	end if
	
	tell TVBrowserCalendar
		if myMode is "set" then
			-- normally the event should be created in iCal
			set createEvent to true
			set eventWasModified to false
			
			set myChannelName to (item 1 of (stringToList of me from mySummary for ""))
			-- find previously created, similar events 
			set myEvents to (events whose start date  (myStartDate - fuzzyTime) and end date  (myEndDate + fuzzyTime) and summary contains myChannelName)
			
			try
				myEvents is ""
			on error
				set myEvents to ""
			end try
			
			
			-- This results in an error if no previously created events are found that match the one to be created
			if myEvents is not "" then
				-- check one event after the other
				repeat with n from 1 to count of items of myEvents
					set myEvent to item n of myEvents
					-- if it's the first event
					if n = 1 then
						-- modify/update it to match the new start and end
						tell myEvent
							--set start date to myStartDate
							--set end date to myEndDate
							set recurrence to myRecurrence
							set summary to mySummary
							set description to myDescription
						end tell
						-- the event was modified with the new start and end
						-- it needn't be created
						set createEvent to false
					else
						-- if it is not the first it very probably is a duplicate of the first and should be deleted
						delete myEvent
					end if
					(*
					set myEvent to item n of myEvents
					tell myEvent
						-- if the event has a similar lenght
						set newLenght to myEndDate - myStartDate
						set oldLenght to start date - end date
						set lenghtDifference to oldLenght - newLenght
						-- the following will still cause problems for events in the same time frame that are similar in lenght and occur on the same channel
						if 2 * fuzzyTime  my makePositive(lenghtDifference) then
--
						if n = 1 then
							-- if the event is similar in lenght and was modified already it very probably is a duplicate of the first and should be deleted
							if eventWasModified then delete myEvent
							-- modify/update it to match the new start and end
							set start date to myStartDate
							set end date to myEndDate
							set recurrence to myRecurrence
							set summary to mySummary
							set description to myDescription
							-- the event was modified with the new start and end
							-- it needn't be created
							set createEvent to false
							set eventWasModified to true
						else
							-- if the event doesn't have a similar lenght and occurs very near to the sought event it should be left alone. It could be a very short news programm right before or after the sought event. 
						end if
--
							delete myEvent
						end if
					end tell
						*)
					
				end repeat
			end if
			
			if createEvent then
				set myEvent to make new event at end of events with properties {summary:mySummary, start date:myStartDate, end date:myEndDate, description:myDescription}
				return "Event created"
				--return the result & " created"
				
			end if
			
		else if myMode is "del" then
			try
				set myChannelName to (item 1 of (stringToList of me from mySummary for ""))
				set myEvents to (events whose start date  (myStartDate - fuzzyTime) and end date  (myEndDate + fuzzyTime) and summary contains myChannelName)
				
				if myEvents is not "" then
					repeat with myEvent in myEvents
						delete myEvent
					end repeat
				end if
				
				return "event removed"
				
			end try
		else
			return "parameter error"
		end if
	end tell
end tell
